Unit afj0z_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAF13_p;

procedure afj0z(var BR :Array of Extended; var BI :Array of Extended;
                var CR :Array of Extended; var CI :Array of Extended;
                N :Integer; var IERR :Integer);

implementation

procedure afj0z(var BR :Array of Extended; var BI :Array of Extended;
                var CR :Array of Extended; var CI :Array of Extended;
                N :Integer; var IERR :Integer);
var
I :Integer;
W,UR,UI,BRI,BII,CRI,CII,B,SB,C,SC,S :Extended;
CB,CC :Complex;
const
SYS052 :Extended = 2.22044592e-16;
SYS056 :Extended = 5.56268464627e-308;
label
_1,_2,_3,_4,_5,_6,_7;
begin
W := 8.e0*SYS052;
IERR := 0;
CR[0] := 1.e0;
CI[0] := 0.e0;
UR := 1.e0;
UI := 0.e0;
if ( N = 1 ) 
 then goto _7;
for I:=2 to N do
 begin
  BRI := BR[I-1];
  BII := BI[I-1];
  CRI := CR[I-1];
  CII := CI[I-1];
  CB := Cmplx(BRI,BII);
  B := Cabs(CB);
  SB := Sqrt(B);
  CC := Cmplx(CRI,CII);
  C := Cabs(CC);
  SC := Sqrt(C);
  S := SB*SC;
  BR[I-1] := S;
  if ( B = 0.e0 ) and ( C = 0.e0 ) 
   then goto _2;
  if ( S = 0.e0 ) 
   then goto _6;
  SB := BRI/B;
  SC := CRI/C;
  if ( Abs(SB-SC) > (Abs(SB)+Abs(SC))*W ) 
   then goto _5;
  SB := 0.e0;
  SC := 0.e0;
  if ( BII <> 0.e0 ) 
   then SB := Sign(1.e0,BII);
  if ( CII <> 0.e0 ) 
   then SC := -Sign(1.e0,CII);
  if ( SB <> SC ) 
   then goto _5;
  if ( IERR = 68 ) 
   then goto _4;
  S := 1.e0/S;
  CRI := CRI*S;
  CII := CII*S;
  C := EMax1(Abs(CRI),Abs(CII));
  B := EMax1(Abs(UR),Abs(UI));
  if ( C*SYS056*B < 0.5e0 ) 
   then goto _1;
  IERR := 68;
  goto _4;
_1:
  BRI := UR*CRI-UI*CII;
  BII := UI*CRI+UR*CII;
  goto _3;
_2:
  BRI := 1.e0;
  BII := 0.e0;
_3:
  CR[I-1] := BRI;
  CI[I-1] := BII;
  UR := BRI;
  UI := BII;
  if ( UR = 0.e0 ) and ( UI = 0.e0 ) 
   then IERR := 68;
_4:
 end;
goto _7;
_5:
IERR := 66;
goto _7;
_6:
IERR := 67;
_7:
if ( IERR <> 0 ) 
 then UTAF13(IERR,4);
end;

end.
